hud-5475 An easy problem(线段树)

http://acm.hdu.edu.cn/showproblem.php?pid=5475

题意:

原数开始时是1按顺序给你Q个操作,然后其中操作分两种。

1表示将上个操作后的数乘以后面给你的数然后对取余,然后输出结果,2表示除的操作,将现在的数除以指定的先前你所乘上的第几个数

然后对M取模。

思路:

这题用线段树写,断点更新,复杂度是n*(log(n));

代码:

  1 #include<stdio.h>
  2 #include<algorithm>
  3 #include<iostream>
  4 #include<string.h>
  5 #include<stdlib.h>
  6 typedef long long LL;
  7 void up(LL k,LL l);
  8 void build(LL l,LL r,LL k);
  9 LL que(LL l,LL r,LL k,LL aa,LL dd);
 10 typedef struct pp
 11 {
 12     LL x;
 13     LL y;
 14     LL id;
 15     LL t;
 16 } ss;
 17 typedef struct tree1
 18 {
 19     LL x;
 20     LL y;
 21     LL id;
 22     LL cou;
 23 } sd;
 24 LL M,N;
 25 ss cnt[100005];
 26 int flag[4*100005];
 27 sd tree[4*100005];
 28 using namespace std;
 29 int main(void)
 30 {
 31     LL n,i,j,k,p,q;
 32     scanf("%lld",&n);
 33     for(i=1; i<=n; i++)
 34     {
 35         scanf("%lld %lld",&N,&M);
 36         memset(tree,0,sizeof(tree));
 37         for(j=1; j<=N; j++)
 38         {
 39             scanf("%lld %lld",&cnt[j].x,&cnt[j].y);
 40             cnt[j].id=j;
 41             if(cnt[j].x==1)
 42             {
 43                 cnt[j].t=cnt[j].y;//操作1时所要乘的数。
 44             }
 45             else cnt[j].t=1;//操作2时乘的数等价为1;
 46         }
 47         build(1,N,0);//建树(因为每步操作都有对应的操作,所以将操作2也放入一起操所,等价为所要乘的数为1)
 48         printf("Case #%lld:\n",i);
 49         for(j=1; j<=N; j++)
 50         {
 51             if(cnt[j].x==1)
 52             {
 53                 LL dd=que(1,j,0,1,N);//当1时询问找点
 54                 printf("%lld\n",dd);
 55             }
 56             else if(cnt[j].x==2)
 57             {
 58                 up(flag[cnt[j].y],j);//当2时断点更新
 59                 LL dd=que(1,j,0,1,N);//询问找点
 60                 printf("%lld\n",dd);
 61             }
 62         }
 63     }
 64     return 0;
 65 }
 66 void build(LL l,LL r,LL k)//建树
 67 {
 68     tree[k].x=l;
 69     tree[k].y=r;
 70     if(l==r)
 71     {
 72         tree[k].cou=cnt[l].t%M;
 73         flag[l]=k;
 74         return;
 75     }
 76     else
 77     {
 78         build(l,(l+r)/2,2*k+1);
 79         build((l+r)/2+1,r,2*k+2);
 80         tree[k].cou=(tree[2*k+1].cou*tree[2*k+2].cou)%M;
 81     }
 82 }
 83 void up(LL k,LL l)//断点更新
 84 {
 85     tree[k].cou=1;//要删除的点处就相当于乘
 86     k=(k-1)/2;
 87     while(k>=0)//向上更新到根结点
 88     {
 89         tree[k].cou=(tree[2*k+1].cou*tree[2*k+2].cou)%M;
 90         if(k==0)
 91         {
 92             break;
 93         }
 94         k=(k-1)/2;
 95     }
 96 }
 97 LL que(LL l,LL r,LL k,LL aa,LL dd)//询问
 98 {
 99     if(l>dd||r<aa)
100     {
101         return 1;
102     }
103     else if(l<=aa&&r>=dd)
104     {
105         return tree[k].cou;
106     }
107     else
108     {
109         LL nx=que(l,r,2*k+1,aa,(aa+dd)/2);
110         LL ny=que(l,r,2*k+2,(aa+dd)/2+1,dd);
111         return (nx*ny)%M;
112     }
113
114 }
时间: 2024-10-10 09:41:33

hud-5475 An easy problem(线段树)的相关文章

HDU 5475 An easy problem(线段树)

题目链接: 戳我 题目大意: 一个计算器只有两种运算,初始化 X = 1 第一种操作: X 乘以 一个数,获得新的 X 第二种操作: 当前的 X 除以 一个数 输出  X % M 其中 1 y 表示第一种操作,即 X  = X * y 2 n 表示 X 除以 前面的 第 n 个操作的那个 y,保证 第 n 个表示的是 1,即数据合法 注意:X 在进行操作的时候不要除模, 而是输出的时候除模,即要保证 X 进行操作的时候除模是和不除模情况下是相等的. 比如: 3 10 1 5 1 3 2 1,如果

2015上海网络赛 HDU 5475 An easy problem 线段树

题意就不说了 思路:线段树,维护区间乘积.2操作就将要除的点更新为1. 1 #include<iostream> 2 #include<cstdio> 3 #include<cstring> 4 #include<cmath> 5 #include<algorithm> 6 #include<queue> 7 #include<vector> 8 #include<set> 9 #include<stri

ZOJ 3686 A Simple Tree Problem(线段树)

A Simple Tree Problem Time Limit: 3 Seconds      Memory Limit: 65536 KB Given a rooted tree, each node has a boolean (0 or 1) labeled on it. Initially, all the labels are 0. We define this kind of operation: given a subtree, negate all its labels. An

hdu 5152 A Strange Problem线段树+欧拉函数

*****************************************BC题解**********************************************************************1003 A Strange Problem 对于操作二,利用公式 当x >= Phi(C), A^x = A ^ (x%Phi(C) + Phi(C)) (mod C) 对于2333333这个模数来说,求18次欧拉函数后就变成了1,所以只需要保存19层第三次操作的加数

spoj IITWPC4F - Gopu and the Grid Problem 线段树

IITWPC4F - Gopu and the Grid Problem no tags Gopu is interested in the integer co-ordinates of the X-Y plane (0<=x,y<=100000). Each integer coordinate contain a lamp, initially all the lamps are in off mode. Flipping a lamp means switching it on if

hdu5107 K-short Problem(线段树+离散化+思维)

题目链接: huangjing 题意:就是给出狠点建筑的坐标和高度,然后给出很多询问,求在这个坐标右下角的第k矮的建筑.. 思路:太弱了我,这个题目从上个星期天就开始看,但是一直不会,所以只能看别人思路,因为那个k小于10,所以左右节点只取前十就可以了,但是我觉得万一不记录完全万一发生丢失怎么办,后来一想sb了,如果左右节点都取前10的话,那么根节点得到的20个值,在排序必定取到了前10啊...言归正传,这道题因为数据范围太大了,前对建筑和询问一起排序,按x从小到大,再按y从小到大,在按建筑优先

hdu 5107 K-short Problem(线段树)

题目链接:hdu 5107 K-short Problem 题目大意:有N个点,M次询问,每次询问点X,Y,K,表示在点集合{(x,y)|x≤X,y≤Y}中高度第K小的值是多少,没有的 话输出-1. 解题思路:线段树,每个节点维护10个高度(因为K最大为10),将询问和点按照x,y的大小排序,从左向右,从下向 上,每次询问就查询[0,idx(y)]即可.注意如果询问和点的位置相同,要先插入点. #include <cstdio> #include <cstring> #includ

bzoj 3489 A simple rmq problem - 线段树

Description 因为是OJ上的题,就简单点好了.给出一个长度为n的序列,给出M个询问:在[l,r]之间找到一个在这个区间里只出现过一次的数,并且要求找的这个数尽可能大.如果找不到这样的数,则直接输出0.我会采取一些措施强制在线. Input 第一行为两个整数N,M.M是询问数,N是序列的长度(N<=100000,M<=200000) 第二行为N个整数,描述这个序列{ai},其中所有1<=ai<=N 再下面M行,每行两个整数x,y, 询问区间[l,r]由下列规则产生(OIER

【CF903G】Yet Another Maxflow Problem 线段树

[CF903G]Yet Another Maxflow Problem 题意:一张图分为两部分,左边有n个点A,右边有m个点B,所有Ai->Ai+1有边,所有Bi->Bi+1有边,某些Ai->Bj有边,每条边都有一定的容量. 先要求你支持两种操作: 1.修改某条Ai->Ai+1的边的容量2.询问从A1到Bm的最大流 n,m<=100000,流量<=10^9 题解:很有思维含量的题. 首先,我们把求最大流变成求最小割.容易发现,我们最多只会割一条Ai->Ai+1的边